<?php namespace Phpcmf\Controllers\Admin;
/* *
 *
 * 本Demo的语法参考： http://help.phpcmf.net/445.html
 *
 * */
class Test extends \Phpcmf\Table
{

	public function __construct(...$params)
	{
		parent::__construct(...$params);
		// 表单显示名称
		$this->name = dr_lang('资料数据');
		// 模板前缀(避免混淆)
		$this->tpl_prefix = 'test_';
		// 用于表储存的字段，后台可修改的表字段
		$field = array(
			'title' => array(
				'name' => dr_lang('主题'),
				'fieldname' => 'title', // 这是字段名称必须和主键相同
			),
			'content' => array(
				'name' => dr_lang('内容'),
				'fieldname' => 'content', // 这是字段名称必须和主键相同
			),
		);
        // 表单显示名称
        $this->name = dr_lang('Test演示表');
		// 初始化数据表
		$this->_init([
			'table' => 'test',  // （不带前缀的）表名字
			'field' => $field, // 可查询的字段
            'order_by' => 'inputtime desc', // 列表排序
            'date_field' => 'inputtime', // 按时间段搜索字段
		]);
		
		// 把公共变量传入模板
		\Phpcmf\Service::V()->assign([
			// 搜索字段
			'field' => $field,
			// 后台的菜单
			'menu' => \Phpcmf\Service::M('auth')->_admin_menu(
			[
				$this->name => [APP_DIR.'/'.\Phpcmf\Service::L('Router')->class.'/index', 'fa fa-tag'],
				'添加' => [APP_DIR.'/'.\Phpcmf\Service::L('Router')->class.'/add', 'fa fa-plus'],
				'修改' => ['hide:'.APP_DIR.'/'.\Phpcmf\Service::L('Router')->class.'/edit', 'fa fa-edit'],
			])
		]);
	}

    // 查看列表
    public function index() {
        list($tpl) = $this->_List();
        \Phpcmf\Service::V()->display($tpl);
    }

    // 添加内容
    public function add() {
        list($tpl) = $this->_Post(0);
        \Phpcmf\Service::V()->display($tpl);
    }

    // 修改内容
    public function edit() {
        list($tpl) = $this->_Post(intval(\Phpcmf\Service::L('Input')->get('id')));
        \Phpcmf\Service::V()->display($tpl);
    }

    // 删除内容
    public function del() {
        $this->_Del(
            \Phpcmf\Service::L('Input')->get_post_ids(),
            null,
            null,
            \Phpcmf\Service::M()->dbprefix($this->init['table'])
        );
    }
	

    // 保存内容 
    protected function _Save($id = 0, $data = [], $old = [], $func = null, $func2 = null) {
        $data = \Phpcmf\Service::L('input')->post('data');
        return parent::_Save($id, $data, $old, function($id, $data, $old){
			// 验证数据
			if (!$data['title']) {
				return dr_return_data(0, '标题不能为空！', ['field' => 'title']);
			}
            // 保存之前执行的函数，并返回新的数据
            if (!$id) {
                // 当提交新数据时，把当前时间插入进去
                $data['inputtime'] = SYS_TIME;
            }
            
            return dr_return_data(1, null, $data);
        }, function ($id, $data, $old) {
            // 保存之后执行的动作
        });
    }

}
